#!/usr/bin/perl
######################################################################
# Copyright 1995,1996,1997 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################
# $Id: flows.pl,v 1.10 1997/04/29 01:23:55 fan Exp $
#
# flows.pl - the main for flow stats, will let pm to start poll.pl
#
# History:
#   ~ 1/97: creation
#     1/97: fixed wrongly reading previous db after reboot - fan
######################################################################
$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";
$TMPLDIR= "/usr/local/monitor/templates";
$STATSAF= "/tmp/stats.access";

        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';
        require 'info-lib.pl';

	$hostname = &IpswitchName();

        &ReadInput(*INPUT);
        &ParseData(*GLOBAL, $INPUT);
	&GetIpsInfo();
        if ($IPSDEVTYPE eq "controller") { 
#	    &PrintButtonBar("HEADER", "Flow Statistics on $hostname"); 
        &DispHelp("Flow Statistics on $hostname");
	} elsif ($IPSDEVTYPE eq "gateway") {
#		&PrintButtonBar("HEADER", "No Flow View Available on $hostname"); 
#        	&PrintButtonBar("TRAILER");
        &DispHelp("No Flow View Available on $hostname");
        &PrintToe;
	return;
	} else {
	    #&PrintButtonBar("HEADER", "Flow Statistics on $hostname");  # BOGUS @@
	}
	&form(); 
#        &PrintButtonBar("TRAILER");
        &PrintToe;

        open(SF, ">$STATSAF");   # Touch the stats file
        print SF " ";
        close(SF);
        open(SF, "$STATSAF");   
        $trash= <SF>;
        close(SF);

        &procstart();

sub PrintToe {
    &SetUpHelp;
        &PrintHeadToe("TRAILER",
                      "", 
                      "",
                      "",
                      "/cgi-bin/flows.pl?IH=$nhelp",
                      "");
}

sub DispHelp {
    local($msg) = @_;
    &SetUpHelp;
        &PrintHeadToe("HEADER",
                      $msg,
                      "",
                      "",
                      "/cgi-bin/flows.pl?IH=$nhelp",
                      "");
    if ($ihelp eq "on") {
        print "<img src=\"/images/config/helpbar.gif\"><br>";
    print "<font -= 4><br>"; 
    open(FD, "/usr/local/config/help/monitor.flowStats.html");
    while (<FD>) {
	print;    
    }             
    close(FD);    
    print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub get {
  local($thing) = @_;
  open (FD, "/usr/local/config/bin/dbget $thing |");
  $result=<FD>;
  close(FD);
  chop($result);
  return($result);
}

sub procstart {
    system("/usr/local/config/bin/udw machine:$machine:process:poll.pl t");
    system("/usr/local/config/bin/dbset machine:$machine:process:poll.pl t");
    return(1);
}

sub KillDBInit { 
    $machine=&get("machine"); 
    $ifPolled=&get("machine:${machine}:process:poll.pl"); 
    if (!$ifPolled) { 
	system("/bin/rm", "/usr/local/monitor/data/flow_stats.db"); 
    } 
    return($ifPolled); 
}    

sub form {

	local($start) = 0;
	($counts) = 0;
	local($tmpl) = "$TMPLDIR/flows.tmpl";
	local($s);
	local($lineNum) = 1;
	local($countNum);
	local($_);

	$poll = &KillDBInit(); 
        if ($poll) { 
	    dbmopen(%flow_stats, '/usr/local/monitor/data/flow_stats', 0666); 
        } 

	$countNum = $flow_stats{"interval.countNum"};
	if (++$countNum > 12 || $flow_stats{"interval.$countNum.total_cells"} eq "")
		{ $countNum = 1; }

	if(!open(READTMPL, $tmpl))
		{ &PrintMsgHdr("Can't open $tmpl: $!"); return 1; }
	while (<READTMPL>) {
                if (/START/)
			{ $start = 1; next; }
		if (/END/)
			{ $start = 0; next; }
		if ($start) 
			{ $count_tmpl{$lineNum++} = $_; next; }
		# Replace IP Switch name
		if (/\@ipswitch\@/)
			{ $s= &IpswitchName; s/\@ipswitch\@/$s/; }
		if (/COUNT/) {
			while (++$counts < 13) {
				$lineNum = 1;
				while ($count_tmpl{$lineNum}) {
					$_ = $count_tmpl{$lineNum++};
					if (/\@(\S*)\@/)
						{ $_= &MapTempVal($1,$_,$countNum); }
					print "$_";
				}
				if (++$countNum > 12)
					{ $countNum = 1; }
			}
		}
		print "$_";
	}
	close(READTMPL);
	dbmclose(flow_stats);
}

sub MapTempVal {
local($mSub,$line,$index) = @_; 
local($s) = &$mSub($index);

	$line =~ s/\@$mSub\@/$s/; return $line; 
}

sub GetInterval {
	return $counts;
}

sub GetSwitchedCells {
local($count) = @_;
	return $flow_stats{"interval.$count.switched.cells"};
}

sub GetSwitchedBytes {
local($count) = @_;
	return $flow_stats{"interval.$count.switched.bytes"};
}

sub GetSwitchedPC {
local($count) = @_;
	return $flow_stats{"interval.$count.switched.percent"};
}

sub GetForwardedCells {
local($count) = @_;
	return $flow_stats{"interval.$count.forwarded.cells"};
}

sub GetForwardedBytes {
local($count) = @_;
	return $flow_stats{"interval.$count.forwarded.bytes"};
}

sub GetForwardedPC {
local($count) = @_;
	return $flow_stats{"interval.$count.forwarded.percent"};
}

